<template>
  <div :class="['tabs-head', layout, pageWidth]">
    <a-tabs
        type="editable-card"
        :class="['tabs-container', layout, pageWidth, {'affixed' : affixed, 'fixed-header' : fixedHeader, 'collapsed' : adminLayout.collapsed}]"
        :active-key="active"
        :hide-add="true"
    >
      <a-tooltip placement="left" :title="lockTitle" slot="tabBarExtraContent">
        <a-icon
            theme="filled"
            @click="onLockClick"
            class="header-lock"
            :type="fixedTabs ? 'lock' : 'unlock'"
        />
      </a-tooltip>
      <a-tab-pane v-for="page in pageList" :key="page.path">
        <div slot="tab" class="tab" @contextmenu="e => onContextmenu(page.path, e)">
          <a-icon @click="onRefresh(page)" :class="['icon-sync', {'hide': page.path !== active && !page.loading}]" :type="page.loading ? 'loading' : 'sync'" />
          <div class="title" @click="onTabClick(page.path)" >{{pageName(page)}}</div>
          <a-icon v-if="!page.unclose" @click="onClose(page.path)" class="icon-close" type="close"/>
        </div>
      </a-tab-pane>
    </a-tabs>
    <div v-if="affixed" class="virtual-tabs"></div>
  </div>
</template>

<script>
  import {mapState, mapMutations} from 'vuex' // 加载vuex mapState、mapMutations
  import {getI18nKey} from '@/utils/routerUtil' // 加载路由工具

  export default {
    name: 'TabsHead', // 组件名称
    i18n: { // 国际化
      messages: { // 国际化信息
        CN: {
          lock: '点击锁定页签头',
          unlock: '点击解除锁定',
        },
        HK: {
          lock: '點擊鎖定頁簽頭',
          unlock: '點擊解除鎖定',
        },
        US: {
          lock: 'click to lock the tabs head',
          unlock: 'click to unlock',
        }
      }
    },
    props: { // 属性
      pageList: Array, // 页面列表
      active: String, // 激活的页面
      fixed: Boolean // 固定
    },
    data() {
      return {
        affixed: false, // 固定
      }
    },
    inject:['adminLayout'], // 注入
    created() { // 创建
      
      this.affixed = this.fixedTabs // 固定 = 固定页签
    },
    computed: {
      
      ...mapState('setting', ['layout', 'pageWidth', 'fixedHeader', 'fixedTabs', 'customTitles']), 
      // 获取vuex数据 获取布局、页面宽度、固定头部、固定页签、自定义标题
      lockTitle() { // 锁定标题
        return this.$t(this.fixedTabs ? 'unlock' : 'lock') // 锁定页签头
      }
    },
    methods: {
      ...mapMutations('setting', ['setFixedTabs']), // 设置固定页签
      onLockClick() { // 锁定点击
        this.setFixedTabs(!this.fixedTabs) // 设置固定页签
        if (this.fixedTabs) { // 固定页签
          setTimeout(() => { // 设置延时
            this.affixed = true // 固定
          }, 200) // 延时200毫秒
        } else { // 未固定页签
          this.affixed = false // 未固定
        }
      },
      onTabClick(key) { // 页签点击
        if (this.active !== key) { // 激活的页面不等于key
          this.$emit('change', key) // 触发change事件
        }
      },
      onClose(key) { // 关闭
        this.$emit('close', key) // 触发close事件
      },
      onRefresh(page) { // 刷新
        this.$emit('refresh', page.path, page) // 触发refresh事件
      },
      onContextmenu(pageKey, e) { // 右键菜单
        this.$emit('contextmenu', pageKey, e) // 触发contextmenu事件
      },
      pageName(page) { // 页面名称
        const pagePath = page.fullPath.split('?')[0] // 页面路径
        const custom = this.customTitles.find(item => item.path === pagePath) // 自定义标题
        return (custom && custom.title) || page.title || this.$t(getI18nKey(page.keyPath)) // 自定义标题 || 页面标题 || 国际化面包屑
      }
    }
  }
</script>

<style scoped lang="less">
  .tab{
    margin: 0 -16px;
    padding: 0 16px;
    font-size: 14px;
    user-select: none;
    transition: all 0.2s;
    .title{
      display: inline-block;
      height: 100%;
    }
    .icon-close{
      font-size: 12px;
      margin-left: 6px;
      margin-right: -4px !important;
      color: @text-color-second;
      &:hover{
        color: @text-color;
      }
    }
    .icon-sync{
      margin-left: -4px;
      color: @primary-4;
      transition: all 0.3s ease-in-out;
      &:hover{
        color: @primary-color;
      }
      font-size: 14px;
      &.hide{
        font-size: 0;
      }
    }
  }
  .tabs-head{
    margin: 0 auto;
    &.head.fixed{
      width: 1400px;
    }
  }
  .tabs-container{
    margin: -16px auto 8px;
    transition: top,left 0.2s;
    .header-lock{
      font-size: 18px;
      cursor: pointer;
      color: @primary-3;
      &:hover{
        color: @primary-color;
      }
    }
    &.affixed{
      margin: 0 auto;
      top: 0px;
      padding: 8px 24px 0;
      position: fixed;
      height: 48px;
      z-index: 1;
      background-color: @layout-body-background;
      &.side,&.mix{
        right: 0;
        left: 256px;
        &.collapsed{
          left: 80px;
        }
      }
      &.head{
        width: inherit;
        padding: 8px 0 0;
        &.fluid{
          left: 0;
          right: 0;
          padding: 8px 24px 0;
        }
      }
      &.fixed-header{
        top: 64px;
      }
    }
  }
  .virtual-tabs{
    height: 48px;
  }
</style>
